/* Copyright (c) 1994, 1995, 1996, Takayuki Hosoda. All rights reserved. */
/* feal.c version 1.3.9 */

#include "feal.h"

#ifndef MSDOS_ASM
#define      rol2(al) ((al << 2) | (al >> 6))

static unsigned short k[72];	/* n + 8, n(max) = 64 */
static unsigned short *kn = &k[32];

static unsigned long
fk(a, b)
    unsigned long   a;
    unsigned long   b;
{
    register unsigned char al;
    register unsigned char ah;
    register unsigned char dl;
    register unsigned char dh;
    register unsigned char bl;
    register unsigned char bh;

    al = (unsigned char) (a & 0xff);
    ah = (unsigned char) ((a >> 8) & 0xff);
    dl = (unsigned char) ((a >>16) & 0xff);
    dh = (unsigned char) (a >>24);

    bl = (unsigned char) (b & 0xff);
    bh = (unsigned char) ((b >> 8) & 0xff);
    ah ^= al;
    dl ^= dh;
    bl ^= dl;
    ah += bl;
    ah++;
    ah = rol2(ah);
    bh ^= ah;
    dl += bh;
    dl = rol2(dl);
    bh = (unsigned char) (b >> 24);
    bl = (unsigned char) ((b >> 16) & 0xff);
    bh ^= dl;
    bl ^= ah;
    dh += bh;
    al += bl;
    dh++;
    al = rol2(al);
    dh = rol2(dh);

    return(((unsigned long)(dh) << 24)
          |((unsigned long)(dl) << 16)
          |((unsigned long)(ah) <<  8)
          |((unsigned long)(al)      ));
}

int
fealskey(key, n)
    unsigned char   key[];
    int             n;		/* 2^2 <= n <= 2^6 */
{
    register unsigned long eax;
    register unsigned long ebx;
    register unsigned long ecx;
    unsigned long   qax;
    unsigned long   qbx;
    unsigned long   qcx;
    unsigned short *sp;
    register unsigned char  *cp;
    register int    i;

    n = (n <= 0 ? -n : n);
    i = 3;
    if(n == 8){
    }else{
	i = 4;
        if(n == 16){
        }else{
            i = 7;
            if(n == 32){
            }else{
                i = 12;
                if(n == 64){
                }else{
                    return(-1);
		}
	    }
	}
    }

    ecx = 0L;
    cp = key;
    kn = &k[n];

    eax = (((unsigned long) *(cp )       )
          |((unsigned long) *(cp+ 1) << 8) 
          |((unsigned long) *(cp+ 2) <<16) 
          |((unsigned long) *(cp+ 3) <<24));
    ebx = (((unsigned long) *(cp+ 4)     )
          |((unsigned long) *(cp+ 5) << 8) 
          |((unsigned long) *(cp+ 6) <<16) 
          |((unsigned long) *(cp+ 7) <<24));
    qbx = (((unsigned long) *(cp+ 8)     )
          |((unsigned long) *(cp+ 9) << 8) 
          |((unsigned long) *(cp+10) <<16) 
          |((unsigned long) *(cp+11) <<24));
    qcx = (((unsigned long) *(cp+12)     )
          |((unsigned long) *(cp+13) << 8) 
          |((unsigned long) *(cp+14) <<16) 
          |((unsigned long) *(cp+15) <<24));
    qax = qbx ^ qcx;
    sp = k;
    for (; i; i--) {
	ecx = fk(eax, ebx ^ ecx ^ qax);
	eax = fk(ebx, ecx ^ eax ^ qbx);
	ebx = fk(ecx, eax ^ ebx ^ qcx);
	*(sp) = (unsigned short) (ecx & 0xffff);
	*(sp+1) = (unsigned short) (ecx >> 16);
	*(sp+2) = (unsigned short) (eax & 0xffff);
	*(sp+3) = (unsigned short) (eax >> 16);
	*(sp+4) = (unsigned short) (ebx & 0xffff);
	*(sp+5) = (unsigned short) (ebx >> 16);
	sp += 6;
    }
    eax ^= eax;
    ebx = ecx = qax = qbx = qcx = eax;
    return (0);
}

static unsigned long
ff(r, k)
    unsigned long   r;
    unsigned short  k;
{
    register unsigned char al;
    register unsigned char ah;
    register unsigned char dl;
    register unsigned char dh;

    al = (unsigned char) (r & 0xff);
    ah = (unsigned char) ((r >> 8) & 0xff);
    dl = (unsigned char) ((r >>16) & 0xff);
    dh = (unsigned char) (r >> 24);

    ah ^= al;
    dl ^= dh;
    ah ^= (unsigned char)(k & 0xff);
    dl ^= (unsigned char)(k >> 8);
    ah += dl;
    dh++;
    ah++;
    ah = rol2(ah);
    dl += ah;
    dl = rol2(dl);
    al += ah;
    dh += dl;
    al = rol2(al);
    dh = rol2(dh);

    return(((unsigned long)(dh) << 24)
          |((unsigned long)(dl) << 16)
          |((unsigned long)(ah) <<  8)
          |((unsigned long)(al)      ));
}
unsigned char  *
fealnx(in, out, n)
    unsigned char  *in;
    unsigned char  *out;
    int             n;		/* 2^2 <= n <= 2^6 */
{
    register unsigned long   a;
    register unsigned long   b;
    register unsigned short *sp;
    register unsigned char  *cp;

    cp = in;
    a   = (((unsigned long) *(cp )       )
          |((unsigned long) *(cp+ 1) << 8) 
          |((unsigned long) *(cp+ 2) <<16) 
          |((unsigned long) *(cp+ 3) <<24));
    b   = (((unsigned long) *(cp+ 4)     )
          |((unsigned long) *(cp+ 5) << 8) 
          |((unsigned long) *(cp+ 6) <<16) 
          |((unsigned long) *(cp+ 7) <<24));

    if (n > 0) {
	/* encrypt */
	a ^= ((unsigned long) *(kn) | ((unsigned long) *(kn+1) << 16));
	b ^= ((unsigned long) *(kn+2) | ((unsigned long) *(kn+3) << 16));
	b ^= a;
	sp = k;
	do{
	    b ^= ff(a ^= ff(b, *(sp)), *(sp + 1));
	    b ^= ff(a ^= ff(b, *(sp + 2)), *(sp + 3));
	    b ^= ff(a ^= ff(b, *(sp + 4)), *(sp + 5));
	    b ^= ff(a ^= ff(b, *(sp + 6)), *(sp + 7));
	    sp += 8;
	}while(sp < kn);
	a ^= ((unsigned long) *(kn+6) | ((unsigned long) *(kn+7) << 16));
	a ^= b;
	b ^= ((unsigned long) *(kn+4) | ((unsigned long) *(kn+5) << 16));
    } else {
	/* decrypt */
	n = -n;
	a ^= ((unsigned long) *(kn+4) | ((unsigned long) *(kn+5) << 16));
	b ^= ((unsigned long) *(kn+6) | ((unsigned long) *(kn+7) << 16));
	b ^= a;
	sp = kn - 1;
	do{
	    b ^= ff(a ^= ff(b, *(sp)), *(sp - 1));
	    b ^= ff(a ^= ff(b, *(sp - 2)), *(sp - 3));
	    b ^= ff(a ^= ff(b, *(sp - 4)), *(sp - 5));
	    b ^= ff(a ^= ff(b, *(sp - 6)), *(sp - 7));
	    sp -= 8;
	}while(sp > k);
	a ^= ((unsigned long) *(kn+2) | ((unsigned long) *(kn+3) << 16));
	a ^= b;
	b ^= ((unsigned long) *(kn) | ((unsigned long) *(kn+1) << 16));
    }

    cp = out;
    *(cp) = (unsigned char) (b & 0xff);
    *(cp+1) = (unsigned char) ((b >> 8) & 0xff);
    *(cp+2) = (unsigned char) ((b >>16) & 0xff);
    *(cp+3) = (unsigned char) (b >> 24);
    *(cp+4) = (unsigned char) (a & 0xff);
    *(cp+5) = (unsigned char) ((a >> 8) & 0xff);
    *(cp+6) = (unsigned char) ((a >>16) & 0xff);
    *(cp+7) = (unsigned char) (a >> 24);

    return (out);
}
#endif
