/* Copyright (c) 1994, 1995, 1996, Takayuki Hosoda. All rights reserved. */ 
/* feal.h version 1.3.9 */

#if __STDC__
extern int fealskey(unsigned char [], int);
extern unsigned char *fealnx(unsigned char *, unsigned char *, int);
#else
extern int fealskey();
extern unsigned char *fealnx();
#endif

/*
NAME
	fealnx, fealskey

SYNOPSIS
	unsigned char
	*fealnx(unsigned char *in, unsigned char *out, int count);

	int
	fealskey(unsigned char key[], int count);

DESCRIPTION
	fealnx() returns the pointer to output string on success, otherwise
        returns NULL.

        fealskey() returns zero on success, otherwise returns -1.

        The first argument to fealskey() is a character array of length 16. If
        last 8 charactors are set to zero, fealnx() functions as fealn() for
        compatibility. The second is the iteration count to make the expand-
        ed key for fealnx(). The value should be one of 8, 16, 32 or 64.
        The function fealskey() must be performed in advance to use fealnx().
        The function fealnx() encrypts (or decrypts if count is negative) the
        64-bits stored in the 8 characters at in using absolute value of count
        iterations of FEAL and stores the 64-bit result in the 8 characters at
        out.

SEE ALSO
	crypt(3)

	S. Miyaguchi, A.Shiraishi and A.Shimizu. "Fast Data Encipherment 
	Algorithm FEAL-8", REVIEW of the Electrical Communication Laborato-
	ries Vol.36 No.1988.

	Shoji Miyaguchi, Sadami Kurihara, Kazuo Ohta, and Hikaru Morita,
	"Expansion of FEAL Cipher", NTT R&D Vol. 39 No.10, pp.1439-1449, 1990.

BUGS
	No bug found so far.

Takayuki Experimental            Aug 31, 1996                                1
*/

