/* Copyright (c) 1994, 1995, 1996, Takayuki Hosoda. All rights reserved. */
/* fnxcrypt version 1.3.9 */

#include "fnxcrypt.h"

/* xread */
short
xread(fdr, ucp, size)
    int             fdr;
    UCHAR          *ucp;
    short           size;
{
    short           n, rd;

    rd = 0;
    while (rd != size) {
	if (0 >= (n = read(fdr, ucp + rd, size - rd)))
	    break;
	rd += n;
    }
    return ((rd == 0) ? (-1) : rd);
}

/* xopenw */
int
xopenw(file, mode)
    char           *file;
    int             mode;
{
    int             fdw;

    if (!(mode & FORCE))
	if (-1 != (fdw = open(file, O_RDONLY, PERMS)))
	    exit(errmsg(E_EXIST));
    if (-1 == (fdw = open(file, O_CREAT | O_WRONLY | O_BINARY, PERMS)))
	exit(errmsg(E_FOPENW));
    return (fdw);
}

/* wfifo */
int
wfifo(si, size, fdw)
    UCHAR          *si;
    USHORT          size;
    int             fdw;
{
    static UCHAR   *di;
    static UCHAR   *wr_buf = NULL;
    static USHORT   rest;
    int             i;

    if (!wr_buf) {
	if ((wr_buf = (UCHAR *) malloc(BUF_SIZE)) == NULL)
	    return(E_MALLOC);
	di = wr_buf;
	rest = BUF_SIZE;
    }
    if (size == FLUSHBUF) {
	if ((BUF_SIZE - rest) != write(fdw, wr_buf, (BUF_SIZE - rest)))
	    return(E_FWRITE);
	di = wr_buf;
	rest = BUF_SIZE;
    } else {
	if (size <= rest) {
	    rest -= size;
	    for (i = 0; i < size; i++)
		*di++ = *si++;
	} else {
	    size -= rest;
	    for (i = 0; i < rest; i++)
		*di++ = *si++;
	    if (BUF_SIZE != write(fdw, wr_buf, BUF_SIZE))
		return(E_FWRITE);
	    rest = BUF_SIZE - size;
	    di = wr_buf;
	    for (i = 0; i < size; i++)
		*di++ = *si++;
	}
    }
    return(NO_ERR);
}

/* rfifo */
short
rfifo(rbuf, cnt, fdr)
    UCHAR          *rbuf;
    short           cnt;
    int             fdr;
{
    short          size;
    static UCHAR   *rp;
    static UCHAR   *rd_buf = NULL;
    static short    rest;
    register short  i;

    size = cnt;
    if (!rd_buf) {
	if ((rd_buf = (UCHAR *) malloc(BUF_SIZE)) == NULL)
	    exit(errmsg(E_MALLOC));
	rp = rd_buf;
	rest = 0;
    }
    if (size <= rest) {
	rest -= size;
	for (i = 0; i < size; i++)
	    *rbuf++ = *rp++;
    } else {
	size -= rest;
	for (i = 0; i < rest; i++)
	    *rbuf++ = *rp++;
	if (-1 == (i = xread(fdr, rd_buf, BUF_SIZE)))
	    return (rest);
	rest = (USHORT) i;
	rp = rd_buf;
	if (rest < size) {
	    for (i = 0; i < rest; i++)
		*rbuf++ = *rp++;
	    return (rest);
	} else {
	    rest -= size;
	    for (i = 0; i < size; i++)
		*rbuf++ = *rp++;
	}
    }
    return (cnt);
}
