/* Copyright (c) 1994, 1995, 1996, Takayuki Hosoda. All rights reserved. */
/* fnxcrypt version 1.3.9 */

#include <stdio.h>
#include <stdlib.h>

/* #ifdef  MSDOS */
#ifdef  MSDOS
#ifndef __MSDOS__
#define __MSDOS__
#endif
#endif
/* #ifdef   __MSDOS__ */
#ifdef   __MSDOS__
#include <string.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <time.h>
#include <fcntl.h>
#include <io.h>
#endif
/* BSD */
#ifdef   BSD
#include <strings.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/time.h>
#include <unistd.h>
#define __UNIX__
#endif
/* #ifdef   SYSV */
#ifdef   SYSV
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <fcntl.h>
#include <unistd.h>
#define __UNIX__
#endif
/* #ifdef   sun */
#ifdef   sun
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <unistd.h>
#define __UNIX__
#endif

/* #ifdef __MSDOS__ */
#ifdef  __MSDOS__
#define PERMS     S_IREAD|S_IWRITE
#endif
/* #ifdef  __UNIX__ */
#ifdef  __UNIX__
#define O_BINARY  0
#define PERMS     S_IREAD|S_IWRITE|S_IRGRP|S_IROTH
#endif

#define STDIN     0
#define STDOUT    1
#define SWITCHAR  '-'
#define BUF_SIZE  16384
#define FLUSHBUF  0xffff

#define DECRYPT   0
#define ENCRYPT   1
#define CBC       2
#define FORCE     4
#define VERBOSE   8
#define KEY_FILE  16

#define FLAG_CLR  0x000
#define FLAG_RDF  0x001

#define NO_ERR    0x00
#define H_USAGE   0x01
#define E_ARG     0x02
#define E_OPTION  0x03
#define E_FOPENW  0x04
#define E_FOPENR  0x05
#define E_FWRITE  0x06
#define E_MALLOC  0x07
#define E_EOF     0x08
#define E_EXIST   0x09
#define E_ABORT   0x0a
#define E_INTERN  0x0b

#define S_GOT     0
#define S_RETYPE  1
#define S_GET     2
#define S_SHORT   3
#define S_MISMAT  4
#define S_ABORT   5

/* typedef */
typedef unsigned char  UCHAR;
typedef unsigned short USHORT;
typedef unsigned long  ULONG;
typedef int            VOID;

extern int    errmsg();
extern UCHAR *mem_cpy();
extern int    mem_cmp();
extern UCHAR *mem_set();
extern long   get_time();
extern char  *get_pass();
extern short  xread();
extern int    xopenw();
extern int    wfifo();
extern short  rfifo();
extern UCHAR *make_iv();
extern USHORT fnxcrypt();
extern int    parse();

#ifdef sun
extern char    *getpass();
#endif
#ifdef __MSDOS__
extern char    *getpass(char *);
#endif
